import contextlib
import unittest
import io
import unittest.mock
from unittest import TextTestRunner

class MainTest(unittest.TestCase):

    def test_answer(self):

        data = [[1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1],
            [1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 1],
            [1, 1, 1, 0, 1, 3, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 1]]

        def distance_test(a, b):
            return sum([abs(a[i]-b[i]) for i in range(len(a))])

        def all_pairs_test(data):
            dist = [[distance_test(sent1, sent2) for sent1 in data] for sent2 in data]
            return dist

        capturedOutput = io.StringIO()                 
        sys.stdout = capturedOutput                     
        all_pairs(data)
        sys.stdout = sys.__stdout__ 
        output = capturedOutput.getvalue().strip()
        self.assertEqual(output, str(all_pairs_test(data)))

test_suite = unittest.TestLoader().loadTestsFromTestCase(MainTest)
with io.StringIO() as buf:
    # run the tests
    with contextlib.redirect_stdout(buf):
        TextTestRunner(stream=buf).run(test_suite)
    # process (in this case: print) the results
    printTest(buf.getvalue())