import unittest, sys
import io
import unittest.mock
import math

from tmc import points

from tmc.utils import load, get_out

main = load('src.main', 'all_pairs')

class MainTest(unittest.TestCase):
   
    @points('3-7')
    def test_answer(self):
        data = [[1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1],
            [1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 1],
            [1, 1, 1, 0, 1, 3, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 1]]
            
        def distance_test(a, b):
            return sum([abs(a[i]-b[i]) for i in range(len(a))])

        def all_pairs_test(data):
            dist = [[distance_test(sent1, sent2) for sent1 in data] for sent2 in data]
            return dist

        main(data)
        output = get_out()
        self.assertEqual(output, str(all_pairs_test(data)))

if __name__ == '__main__':
    unittest.main()